<?php
/**
 * AutoSOAP - Expanded SOAP Server
 * 
 * PHP version 5
 * 
 * @package jp.servlet.AutoSOAP
 * @author Sakamoto Kouichi <sakamoto@servlet.sakura.ne.jp> 
 * @copyright 2006 Sakamoto Kouichi
 * @license http://www.apache.org/licenses/LICENSE-2.0 Apache Software License 2.0
 * 
 * $Id: traceResponse.filter.php 99 2006-04-23 14:13:00Z sakamoto $
 */

/**
 * レスポンスのトレースフィルター
 * 
 * @package jp.servlet.AutoSOAP.Filters
 * @author Sakamoto Kouichi <sakamoto@servlet.sakura.ne.jp> 
 */
class AutoSOAP_Filters_traceResponse implements AutoSOAP_Filter {
    static $__const;

    public function execute(AutoSOAP_Service $service, $method_name)
    {
        ob_start(array($this,'trace'));
    }

    public function trace($buffer)
    {
        date_default_timezone_set('GMT');
        $file_path = self::$__const->output_dir."/" . date("Ymd", time()) . '.txt';
        
        if (!$handle = fopen($file_path, 'a+')) {
            return $buffer;
        } 
        $data = '['.date("H:i:s", time()) . "]\r\n".$buffer."\r\n";
        fwrite($handle, $data);
        fclose($handle);

        return $buffer;
    }
}
?>